﻿declare @v_portletid as numeric;
declare @v_actionid as numeric;
declare @v_userid as numeric;
declare @v_rightid as numeric;
declare @v_menuitemid as numeric;
declare @v_username as nvarchar(50);
/*Get the user id. Will select all users that are Active Users and Active Resources
This select statement may be modified to include only a specific resource or a group of resources*/
DECLARE c_cursor CURSOR LOCAL FOR 
select s.user_id from prj_resources r, srm_resources s, cmn_sec_users u 
where  r.prid = s.id
and s.user_id = u.id
and s.is_active=1
and u.user_status_id = 200
order by s.user_id
begin
OPEN c_cursor;
FETCH NEXT FROM c_cursor INTO @v_userid;
WHILE (@@FETCH_STATUS = 0)

begin
select @v_username = user_name from cmn_sec_users 
where id =  @v_userid;
print 'Checking user ' + @v_username ;

/*Get the portlet id. If the portlet does not exist, create the portlet and update the captions. */
select @v_portletid =id from cmn_portlets 
where portlet_code like '%union.favLeftNav' 
and principal_id =@v_userid;
if @@rowcount=0
begin
exec CMN_ID_SP 'CMN_PORTLETS', @v_portletid output, 1000, 'CMN_PORTLETS_S1';
INSERT INTO cmn_portlets (
        id, portlet_code, source, category_id, status_code,
        is_wide, mime_type_code, portlet_view_type_code,
        view_source, component_code, portlet_type_code,
        is_system, is_active, instance_type,
        principal_id, principal_type,
        created_date, created_by, last_updated_date, last_updated_by )
        VALUES (@v_portletid,cast(@v_userid as nvarchar)+'.union.favLeftNav','clarity.ca.com',50209,'NORMAL',1,'vxsl','toc','menu.xsl','union','FAVORITE',1,1,'FAVORITE',@v_userid,'USER',getdate(),1,getdate(),1);
 exec cmn_captions_nls_upd_sp 'CMN_PORTLETS',@v_portletid, 'Nabídka Oblíbené', 'Nabídka Oblíbené', 1, null, null, null, null, null,'cs';                        
 exec cmn_captions_nls_upd_sp 'CMN_PORTLETS',@v_portletid, 'Menuen Favoritter', 'Menuen Favoritter', 1, null, null, null, null, null,'da';                      
 exec cmn_captions_nls_upd_sp 'CMN_PORTLETS',@v_portletid, 'Favoritenmenü', 'Favoritenmenü', 1, null, null, null, null, null,'de';                              
 exec cmn_captions_nls_upd_sp 'CMN_PORTLETS',@v_portletid, 'Favorites Menu', 'Favorites Menu', 1, null, null, null, null, null,'en';                            
 exec cmn_captions_nls_upd_sp 'CMN_PORTLETS',@v_portletid, 'Menú de favoritos', 'Menú de favoritos', 1, null, null, null, null, null,'es';                      
 exec cmn_captions_nls_upd_sp 'CMN_PORTLETS',@v_portletid, 'Suosikit-valikko', 'Suosikit-valikko', 1, null, null, null, null, null,'fi';                        
 exec cmn_captions_nls_upd_sp 'CMN_PORTLETS',@v_portletid, 'Menu Favoris', 'Menu Favoris', 1, null, null, null, null, null,'fr';                                
 exec cmn_captions_nls_upd_sp 'CMN_PORTLETS',@v_portletid, 'Kedvencek menü', 'Kedvencek menü', 1, null, null, null, null, null,'hu';                            
 exec cmn_captions_nls_upd_sp 'CMN_PORTLETS',@v_portletid, 'Menu Preferiti', 'Menu Preferiti', 1, null, null, null, null, null,'it';                            
 exec cmn_captions_nls_upd_sp 'CMN_PORTLETS',@v_portletid, 'お気に入りメニュー', 'お気に入りメニュー', 1, null, null, null, null, null,'ja';                                      
 exec cmn_captions_nls_upd_sp 'CMN_PORTLETS',@v_portletid, '즐겨찾기 메뉴', '즐겨찾기 메뉴', 1, null, null, null, null, null,'ko';                                          
 exec cmn_captions_nls_upd_sp 'CMN_PORTLETS',@v_portletid, 'Menu Favorieten', 'Menu Favorieten', 1, null, null, null, null, null,'nl';                          
 exec cmn_captions_nls_upd_sp 'CMN_PORTLETS',@v_portletid, 'Favoritter-meny', 'Favoritter-meny', 1, null, null, null, null, null,'no';                          
 exec cmn_captions_nls_upd_sp 'CMN_PORTLETS',@v_portletid, 'Menu ulubionych', 'Menu ulubionych', 1, null, null, null, null, null,'pl';                          
 exec cmn_captions_nls_upd_sp 'CMN_PORTLETS',@v_portletid, 'Menu Favoritos', 'Menu Favoritos', 1, null, null, null, null, null,'pt';                            
 exec cmn_captions_nls_upd_sp 'CMN_PORTLETS',@v_portletid, 'Меню избранного', 'Меню избранного', 1, null, null, null, null, null,'ru';                          
 exec cmn_captions_nls_upd_sp 'CMN_PORTLETS',@v_portletid, 'Favoriter-meny', 'Favoriter-meny', 1, null, null, null, null, null,'sv';                            
 exec cmn_captions_nls_upd_sp 'CMN_PORTLETS',@v_portletid, 'Sık Kullanılanlar Menüsü', 'Sık Kullanılanlar Menüsü', 1, null, null, null, null, null,'tr';        
 exec cmn_captions_nls_upd_sp 'CMN_PORTLETS',@v_portletid, '收藏夹菜单', '收藏夹菜单', 1, null, null, null, null, null,'zh';                                              
 exec cmn_captions_nls_upd_sp 'CMN_PORTLETS',@v_portletid, '我的最愛功能表', '我的最愛功能表', 1, null, null, null, null, null,'zh_TW'; 	
print 'Inserted portlet ' + cast(@v_portletid as nvarchar);
end;
		  
/* Make sure the Favorites - Edit instance right is created, if not, insert it */ 
select @v_rightid =csaop.id from cmn_sec_assgnd_obj_perm csaop, cmn_sec_groups g
    where g.group_code = 'UserFavoriteEditor'
    and csaop.principal_type = 'USER'
    and csaop.right_id = g.id
    and csaop.principal_id = @v_userid;
if @@rowcount=0
begin
exec cmn_sec_assign_inst_right_sp 'USER', @v_username, 'UserFavoriteEditor', @v_portletid;
print 'Inserted instance right for user ' + @v_username;
end
/* Make sure the action is created, if not, insert it and update the captions */ 
select @v_actionid = id from CMN_ACTIONS where action_code = cast(@v_userid as nvarchar)+'.My Links'; 
if @@rowcount=0
begin
exec CMN_ID_SP 'CMN_ACTIONS', @v_actionid output, 1, 'CMN_ACTIONS_S1';

INSERT INTO CMN_ACTIONS
        ( ID, ACTION_CODE, ALIAS_CODE ,PAGE_ID,TARGET,
        IS_SYSTEM, IS_ACTIVE, IS_SSL_ENABLED,
        PRINCIPAL_TYPE, PRINCIPAL_ID,
        CREATED_DATE, CREATED_BY, LAST_UPDATED_DATE, LAST_UPDATED_BY)
  VALUES
        ( @v_actionid, cast(@v_userid as nvarchar)+'.My Links', null, 0, null,
        0, 0, 0, 'USER', @v_userid,
        getdate(), 1, getdate(), 1);
 exec cmn_captions_nls_upd_sp 'CMN_ACTIONS',@v_actionid, 'Moje odkazy', 'Moje odkazy', 1, null, null, null, null, null,'cs' ;                                  
 exec cmn_captions_nls_upd_sp 'CMN_ACTIONS',@v_actionid, 'Mine links', 'Mine links', 1, null, null, null, null, null,'da' ;                                    
 exec cmn_captions_nls_upd_sp 'CMN_ACTIONS',@v_actionid, 'Eigene Verknüpfungen', 'Eigene Verknüpfungen', 1, null, null, null, null, null,'de' ;                
 exec cmn_captions_nls_upd_sp 'CMN_ACTIONS',@v_actionid, 'My Links', 'My Links', 1, null, null, null, null, null,'en' ;                                        
 exec cmn_captions_nls_upd_sp 'CMN_ACTIONS',@v_actionid, 'Mis vínculos', 'Mis vínculos', 1, null, null, null, null, null,'es' ;                                
 exec cmn_captions_nls_upd_sp 'CMN_ACTIONS',@v_actionid, 'Omat linkit', 'Omat linkit', 1, null, null, null, null, null,'fi' ;                                  
 exec cmn_captions_nls_upd_sp 'CMN_ACTIONS',@v_actionid, 'Mes liens', 'Mes liens', 1, null, null, null, null, null,'fr' ;                                      
 exec cmn_captions_nls_upd_sp 'CMN_ACTIONS',@v_actionid, 'Hivatkozásaim', 'Hivatkozásaim', 1, null, null, null, null, null,'hu' ;                              
 exec cmn_captions_nls_upd_sp 'CMN_ACTIONS',@v_actionid, 'Collegamenti personali', 'Collegamenti personali', 1, null, null, null, null, null,'it' ;            
 exec cmn_captions_nls_upd_sp 'CMN_ACTIONS',@v_actionid, 'マイ リンク', 'マイ リンク', 1, null, null, null, null, null,'ja' ;                                            
 exec cmn_captions_nls_upd_sp 'CMN_ACTIONS',@v_actionid, '내 링크', '내 링크', 1, null, null, null, null, null,'ko' ;                                                
 exec cmn_captions_nls_upd_sp 'CMN_ACTIONS',@v_actionid, 'Mijn koppelingen', 'Mijn koppelingen', 1, null, null, null, null, null,'nl' ;                        
 exec cmn_captions_nls_upd_sp 'CMN_ACTIONS',@v_actionid, 'Mine koblinger', 'Mine koblinger', 1, null, null, null, null, null,'no' ;                            
 exec cmn_captions_nls_upd_sp 'CMN_ACTIONS',@v_actionid, 'Moje łącza', 'Moje łącza', 1, null, null, null, null, null,'pl' ;                                    
 exec cmn_captions_nls_upd_sp 'CMN_ACTIONS',@v_actionid, 'Meus links', 'Meus links', 1, null, null, null, null, null,'pt' ;                                    
 exec cmn_captions_nls_upd_sp 'CMN_ACTIONS',@v_actionid, 'Мои ссылки', 'Мои ссылки', 1, null, null, null, null, null,'ru' ;                                    
 exec cmn_captions_nls_upd_sp 'CMN_ACTIONS',@v_actionid, 'Mina länkar', 'Mina länkar', 1, null, null, null, null, null,'sv' ;                                  
 exec cmn_captions_nls_upd_sp 'CMN_ACTIONS',@v_actionid, 'Bağlantılarım', 'Bağlantılarım', 1, null, null, null, null, null,'tr' ;                              
 exec cmn_captions_nls_upd_sp 'CMN_ACTIONS',@v_actionid, '我的链接', '我的链接', 1, null, null, null, null, null,'zh' ;                                                
 exec cmn_captions_nls_upd_sp 'CMN_ACTIONS',@v_actionid, '我的連結', '我的連結', 1, null, null, null, null, null,'zh_TW' ;   

print 'Inserted action ' + cast (@v_actionid as nvarchar);
end;
/* Make sure the menu items are inserted, if not, insert them */ 
select @v_menuitemid = id from cmn_menu_items 
where principal_id =@v_userid
and container_id = @v_portletid
and action_id = @v_actionid;
if @@rowcount=0
begin
exec CMN_ID_SP 'CMN_MENU_ITEMS', @v_menuitemid output, 1, 'CMN_MENU_ITEMS_S1';
INSERT INTO cmn_menu_items
        (
        id, principal_type, principal_id,
        item_type_code, container_type_code, container_id,
        action_id, parent_menu_id,
        menu_item_level, position, image_name, is_favorite,
        is_default, is_required,
        created_date, created_by,
        last_updated_date, last_updated_by
        )
        VALUES
        ( @v_menuitemid, 'USER', @v_userid,
        'MENU', 'MENU',@v_portletid,
        @v_actionid, null,
        0, 0, null, 1,
        0, 1,
        getdate(), 1,
        getdate(), 1);
print 'Inserted menu ' + cast(@v_menuitemid as nvarchar) + ' for user ' + @v_username;
		end;
FETCH NEXT FROM c_cursor INTO @v_userid;
END;
CLOSE c_cursor;
DEALLOCATE c_cursor
END
